function init()
{
	if(!wmpIsInstalled())
		alert('A Windows Media Player plug-in is not installed for this browser. You may experience problems if you proceed without installing this software first.');
}

function addBeamListItem(id, type, src, title)
{

	var beamList =  document.getElementById('beamList');
	
	if(beamList)
	{
		var itemDiv = document.createElement('div');
		itemDiv.setAttribute('id', id);
		itemDiv.setAttribute('beamtype', type);
		itemDiv.setAttribute('beamsrc', src);
		itemDiv.setAttribute('beamtitle', title);
		itemDiv.setAttribute('onbeamhighlight', 'onBeamHighlight(this.id)');
		itemDiv.setAttribute('onbeamunhighlight', 'onBeamUnhighlight(this.id)');
		beamList.appendChild(itemDiv);	
	}
}

function beamListChanged()
{
	if (document.createEvent)
	{
		var event = document.createEvent("MouseEvents");
		event.initEvent("click", true, false);
		document.getElementById('beamList').dispatchEvent(event);
	}
	else
	{
		var event = document.createEventObject();
		document.getElementById('beamList').fireEvent("onclick", event);
	}	
}

function clearBeamList()
{
	var beamList = document.getElementById('beamList');
	
	if(beamList)
		beamList.innerHTML = '';
}

function onBeamHighlight(id)
{
	var ui = document.getElementById('remoteaccess');
	
	if(ui)
		ui.beamHighlight(id);
}

function onBeamUnhighlight(id)
{
	var ui = document.getElementById('remoteaccess');
	
	if(ui)
		ui.beamUnhighlight(id);
}

/*
 * WMP methods
 * @see http://msdn.microsoft.com/en-us/library/dd564034.aspx
*/

function OnDSPlayStateChangeEvt(state)
{
	var ui = document.getElementById('remoteaccess');
	
	if(ui)
		ui.WMPlayStateChange(state);
}

function OnDSErrorEvt(params)
{
	var desc = document.getElementById('WMPlayer').error.item(0).errorDescription;
	
	var ui = document.getElementById('remoteaccess');
	
	if(ui)
		ui.WMPlayerError(desc);
}

function loadWMPItem(url)
{
	if(wmpIsInstalled())
		document.getElementById('WMPlayer').URL = url;
	else
		OnDSPlayStateChangeEvt(8);
		
}

function wmpPlayItem(item)
{
	document.getElementById('WMPlayer').controls.playItem(item);
}

function wmpPlay()
{
	document.getElementById('WMPlayer').controls.play();
}

function wmpPause()
{
	document.getElementById('WMPlayer').controls.pause();
}

function wmpStop()
{
	document.getElementById('WMPlayer').controls.stop();
}

function wmpGetCurrentPosition()
{
	return document.getElementById('WMPlayer').controls.currentPosition;
}

function wmpSetCurrentPosition(seconds)
{
	document.getElementById('WMPlayer').controls.currentPosition = seconds;
}

function wmpSetVolume(v)
{
	document.getElementById('WMPlayer').settings.volume = v;
}

function wmpGetMute()
{
	return document.getElementById('WMPlayer').settings.mute;
}

function wmpSetMute(flag)
{
	document.getElementById('WMPlayer').settings.mute = flag;
}

/*
 * Utility methods
*/

function wmpIsInstalled()
{
	var isInstalled = false;  
	var version = null;  
	if (window.ActiveXObject) 
	{  
	    var control = null;  
	    try 
	    {  
	        control = new ActiveXObject('WMPlayer.OCX');  
	    } 
	    catch (e) {}
	    
	    return (null != control)  
	} 
	else 
	{  
	    return isPluginInstalled('Windows Media Player');
	}
}

function isPluginInstalled(needle)
{
	var isInstalled = false;
	needle = needle.toLowerCase();
	navigator.plugins.refresh();
	
	for(var ii = 0; ii < navigator.plugins.length; ii++)
	{
		var haystack = navigator.plugins[ii].name.toLowerCase();
		
		if(-1 != haystack.indexOf(needle))
		{
			isInstalled = true;
			break;
		}
	}
	
	return isInstalled;
}
